﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;

namespace KlimaskapLogFixer
{
    class Program
    {
        static StreamReader sr;
        static StreamWriter sw;
        static void Main(string[] args)
        {
            int n = 0;
            string datalinje = "";
            bool ferdig = false;
            while (!ferdig)
            {
                Console.WriteLine("Skriv inn navn på fil som du ønsker å konvertere, innkludert filtype (eksempel.csv)");
                Console.WriteLine("Filen må være i samme mappe som dette programmet");
                string gammelfil = Console.ReadLine();
                Console.WriteLine("Skriv inn nytt filnavn, innkludert type");
                string nyfil = Console.ReadLine();
                try
                {
                    sr = new StreamReader(gammelfil);
                    sw = new StreamWriter(nyfil);
                    ferdig = true;
                }
                catch (Exception u)
                {
                    Console.WriteLine(u.Message);
                    Console.WriteLine("Prøv igjen");
                }
            }

            while (!sr.EndOfStream)
            {
                string[] x = sr.ReadLine().Split(';');
                if (n == 0)
                {
                    sw.WriteLine("Dato;Klokkeslett;Temperatur;Fuktighet;SP_Temperatur;SP_Fuktighet;Wb_Temperature");
                }
                else
                {
                    string number;
                    string[] dato_klokkeslett;


                    switch (x[0].Trim('"'))
                    {
                        case "Temprature":
                            dato_klokkeslett = x[1].Trim('"').Split(' ');
                            datalinje += string.Format("{0};{1}", dato_klokkeslett[0], dato_klokkeslett[1]);
                            number = "";
                            foreach (var item in x[2])
                            {
                                if (item == ',')
                                {
                                    number += ".";
                                }
                                else
                                {
                                    number += item;
                                }
                            }
                            datalinje += string.Format(";{0}", number);
                            break;
                        case "Temprature_LongTerm":
                            dato_klokkeslett = x[1].Trim('"').Split(' ');
                            datalinje += string.Format("{0};{1}", dato_klokkeslett[0], dato_klokkeslett[1]);
                            number = "";
                            foreach (var item in x[2])
                            {
                                if (item == ',')
                                {
                                    number += ".";
                                }
                                else
                                {
                                    number += item;
                                }
                            }
                            datalinje += string.Format(";{0}", number);
                            break;
                        case "Humidity":
                            number = "";
                            foreach (var item in x[2])
                            {
                                if (item == ',')
                                {
                                    number += ".";
                                }
                                else
                                {
                                    number += item;
                                }
                            }
                            datalinje += string.Format(";{0}", number);
                            break;
                        case "Humidity_LongTerm":
                            datalinje += string.Format(";{0}", x[2]);
                            number = "";
                            foreach (var item in x[2])
                            {
                                if (item == ',')
                                {
                                    number += ".";
                                }
                                else
                                {
                                    number += item;
                                }
                            }
                            break;
                        case "SP_Temprature":
                            datalinje += string.Format(";{0}", x[2]);
                            break;
                        case "SP_Temprature_LongTerm":
                            datalinje += string.Format(";{0}", x[2]);
                            break;
                        case "SP_Humidity":
                            datalinje += string.Format(";{0}", x[2]);
                            break;
                        case "SP_Humidity_LongTerm":
                            datalinje += string.Format(";{0}", x[2]);
                            break;
                        case "$RT_DIS$":
                            Console.WriteLine("$RT_DIS$");
                            break;
                        case "Wetbulb_Temprature":
                            number = "";
                            foreach (var item in x[2])
                            {
                                if (item == ',')
                                {
                                    number += ".";
                                }
                                else
                                {
                                    number += item;
                                }
                            }
                            datalinje += string.Format(";{0}", number);
                            sw.WriteLine(datalinje);
                            datalinje = "";
                            break;
                        case "Wetbulb_Temprature_LongTerm":
                            number = "";
                            foreach (var item in x[2])
                            {
                                if (item == ',')
                                {
                                    number += ".";
                                }
                                else
                                {
                                    number += item;
                                }
                            }
                            datalinje += string.Format(";{0}", number);
                            sw.WriteLine(datalinje);
                            datalinje = "";
                            break;
                        case "$RT_COUNT$":
                            Console.WriteLine("Count: {0}", x[1]);
                            break;
                        default:
                            Console.WriteLine("error");
                            break;
                    }


                }
                n++;
            }

            Console.WriteLine("Ferdig. Trykk en knapp få å stenge ned");
            Console.ReadKey();
        }
    }
}
